src/Entity/Loan.php
<?php

namespace App\Entity;

use App\Repository\LoanRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Serializer\Annotation\Groups;

/**
 * @ORM\Entity(repositoryClass=LoanRepository::class)
 */
class Loan
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     * @Groups("loan:read")
     */
    private $id;

    /**
     * @ORM\Column(type="datetime_immutable")
     * @Groups("loan:read")
     */
    private $created_at;

    /**
     * @ORM\Column(type="datetime_immutable")
     * @Groups("loan:read")
     */
    private $finished_at;

    /**
     * @ORM\Column(type="datetime_immutable")
     * @Groups("loan:read")
     */
    private $returned_at;

    /**
     * @ORM\ManyToOne(targetEntity=User::class)
     * @ORM\JoinColumn(nullable=false)
     */
    private $user_id;

    /**
     * @ORM\ManyToOne(targetEntity=Ressource::class)
     * @ORM\JoinColumn(nullable=false)
     */
    private $ressource_id;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getCreatedAt(): ?\DateTimeImmutable
    {
        return $this->created_at;
    }

    public function setCreatedAt(\DateTimeImmutable $created_at): self
    {
        $this->created_at = $created_at;

        return $this;
    }

    public function getFinishedAt(): ?\DateTimeImmutable
    {
        return $this->finished_at;
    }

    public function setFinishedAt(\DateTimeImmutable $finished_at): self
    {
        $this->finished_at = $finished_at;

        return $this;
    }

    public function getReturnedAt(): ?\DateTimeImmutable
    {
        return $this->returned_at;
    }

    public function setReturnedAt(\DateTimeImmutable $returned_at): self
    {
        $this->returned_at = $returned_at;

        return $this;
    }

    public function getUserId(): ?User
    {
        return $this->user_id;
    }

    public function setUserId(?User $user_id): self
    {
        $this->user_id = $user_id;

        return $this;
    }

    public function getRessourceId(): ?Ressource
    {
        return $this->ressource_id;
    }

    public function setRessourceId(?Ressource $ressource_id): self
    {
        $this->ressource_id = $ressource_id;

        return $this;
    }
}

src/Form/LoanType.php
<?php

namespace App\Form;

use App\Entity\Loan;
use App\Entity\User;
use App\Entity\Ressource;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;

class LoanType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('created_at')
            ->add('finished_at')
            ->add('returned_at')
            ->add('user_id', EntityType::class, [
                'class' => User::class,
                'choice_label' => 'id',
                'multiple' => true,
            ])
            ->add('ressource_id', EntityType::class, [
                'class' => Ressource::class,
                'choice_label' => 'label',
                'multiple' => true,
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Loan::class,
        ]);
    }
}

src/Controller/LoanController.php
<?php

namespace App\Controller;

use App\Entity\Loan;
use App\Form\LoanType;
use App\Repository\LoanRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('/loan')]
class LoanController extends AbstractController
{
    #[Route('/', name: 'loan_index', methods: ['GET'])]
    public function index(LoanRepository $loanRepository): Response
    {
        return $this->render('loan/index.html.twig', [
            'loans' => $loanRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'loan_new', methods: ['GET', 'POST'])]
    public function new(Request $request, EntityManagerInterface $entityManager): Response
    {
        $loan = new Loan();
        $form = $this->createForm(LoanType::class, $loan);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->persist($loan);
            $entityManager->flush();

            return $this->redirectToRoute('loan_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('loan/new.html.twig', [
            'loan' => $loan,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'loan_show', methods: ['GET'])]
    public function show(Loan $loan): Response
    {
        return $this->render('loan/show.html.twig', [
            'loan' => $loan,
        ]);
    }

    #[Route('/{id}/edit', name: 'loan_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Loan $loan, EntityManagerInterface $entityManager): Response
    {
        $form = $this->createForm(LoanType::class, $loan);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager->flush();

            return $this->redirectToRoute('loan_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('loan/edit.html.twig', [
            'loan' => $loan,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'loan_delete', methods: ['POST'])]
    public function delete(Request $request, Loan $loan, EntityManagerInterface $entityManager): Response
    {
        if ($this->isCsrfTokenValid('delete'.$loan->getId(), $request->request->get('_token'))) {
            $entityManager->remove($loan);
            $entityManager->flush();
        }

        return $this->redirectToRoute('loan_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/loan/_delete_form.html.twig
<form method="post" action="{{ path('loan_delete', {'id': loan.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ loan.id) }}">
    <button class="btn">Delete</button>
</form>

templates/loan/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/loan/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Loan{% endblock %}

{% block body %}
    <h1>Edit Loan</h1>

    {{ include('loan/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('loan_index') }}">back to list</a>

    {{ include('loan/_delete_form.html.twig') }}
{% endblock %}

templates/loan/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Loan index{% endblock %}

{% block body %}
    <h1>Loan index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Created_at</th>
                <th>Finished_at</th>
                <th>Returned_at</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for loan in loans %}
            <tr>
                <td>{{ loan.id }}</td>
                <td>{{ loan.createdAt ? loan.createdAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>{{ loan.finishedAt ? loan.finishedAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>{{ loan.returnedAt ? loan.returnedAt|date('Y-m-d H:i:s') : '' }}</td>
                <td>
                    <a href="{{ path('loan_show', {'id': loan.id}) }}">show</a>
                    <a href="{{ path('loan_edit', {'id': loan.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="5">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('loan_new') }}">Create new</a>
{% endblock %}

templates/loan/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Loan{% endblock %}

{% block body %}
    <h1>Create new Loan</h1>

    {{ include('loan/_form.html.twig') }}

    <a href="{{ path('loan_index') }}">back to list</a>
{% endblock %}

templates/loan/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Loan{% endblock %}

{% block body %}
    <h1>Loan</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ loan.id }}</td>
            </tr>
            <tr>
                <th>Created_at</th>
                <td>{{ loan.createdAt ? loan.createdAt|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
            <tr>
                <th>Finished_at</th>
                <td>{{ loan.finishedAt ? loan.finishedAt|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
            <tr>
                <th>Returned_at</th>
                <td>{{ loan.returnedAt ? loan.returnedAt|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('loan_index') }}">back to list</a>

    <a href="{{ path('loan_edit', {'id': loan.id}) }}">edit</a>

    {{ include('loan/_delete_form.html.twig') }}
{% endblock %}